// @ts-check

/** @enum {string} */
export const GifNodeType = [
  "root",

  "header",
  "headerSignature",
  "headerVersion",

  "logicalScreenDescriptor",
  "logicalScreenWidth",
  "logicalScreenHeight",
  "logicalScreenDescriptorPackedFields",
  "logicalScreenBackgroundColorIndex",
  "logicalScreenPixelAspectRatio",

  "globalColorTable",
  "globalColorTableColor",

  "imageSection",
  "imageDescriptor",
  "imageSeparator",
  "imageDescriptorLeftPosition",
  "imageDescriptorTopPosition",
  "imageDescriptorWidth",
  "imageDescriptorHeight",
  "imageDescriptorPackedFields",

  "localColorTable",
  "localColorTableColor",

  "imageData",
  "imageDataLzwMinimumCodeSize",
  "imageDataSubBlock",
  "imageDataSubBlockSize",
  "imageDataSubBlockData",
  "imageDataTerminator",

  "extensionBlockIntroducer",
  "extensionBlockSize",
  "extensionBlockTerminator",

  "applicationExtensionBlock",
  "applicationIdentifier",
  "applicationAuthenticationCode",
  "applicationSubBlock",
  "applicationSubBlockSize",
  "applicationSubBlockData",

  "commentSubBlock",
  "commentSubBlockSize",
  "commentSubBlockData",

  "graphicControlExtensionBlock",
  "graphicControlExtensionPackedFields",
  "graphicControlExtensionDelayTime",
  "graphicControlExtensionTransparentColorIndex",

  "plainTextExtensionBlock",
  "plainTextExtensionBlockTextGridLeftPosition",
  "plainTextExtensionBlockTextGridTopPosition",
  "plainTextExtensionBlockTextGridWidth",
  "plainTextExtensionBlockTextGridHeight",
  "plainTextExtensionBlockCharacterCellWidth",
  "plainTextExtensionBlockCharacterCellHeight",
  "plainTextExtensionBlockTextForegroundColorIndex",
  "plainTextExtensionBlockTextBackgroundColorIndex",
  "plainTextSubBlock",
  "plainTextSubBlockSize",
  "plainTextSubBlockData",

  "unknownExtensionBlock",
  "unknownExtensionBlockLabel",
  "unknownExtensionBlockData",

  "gifTerminator",
].reduce((result, id) => {
  result[id] = id;
  return result;
}, Object.create(null));
